package ryulib.ChatControl;

import android.annotation.SuppressLint;
import android.content.Context;
import android.view.Gravity;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

@SuppressLint("ViewConstructor")
public class ChatMessage extends LinearLayout {
	
	public final static int LEFT = 0;
	public final static int RIGHT = 1;
	
	private Context _Context = null;
	private LinearLayout _LinearLayout = null;
	private TextView _Message = null;
	private TextView _UserID = null;
	
	public ChatMessage(Context context, String userID, String text, int direction, int image) {
		super(context);
		
		_Context = context;
		
		LinearLayout.LayoutParams paramsMatchParent = new LinearLayout.LayoutParams(
				ViewGroup.LayoutParams.MATCH_PARENT,
				ViewGroup.LayoutParams.MATCH_PARENT,
				0.0F
		);

		setOrientation(LinearLayout.VERTICAL);
		setLayoutParams(paramsMatchParent);
		
		LinearLayout.LayoutParams paramsWrapContent = new LinearLayout.LayoutParams(
				ViewGroup.LayoutParams.WRAP_CONTENT,
				ViewGroup.LayoutParams.WRAP_CONTENT,
				0.0F
		);
		
		if (RIGHT == direction) paramsWrapContent.gravity = Gravity.RIGHT;

		_LinearLayout = new LinearLayout(context);
		_LinearLayout.setOrientation(LinearLayout.HORIZONTAL);
		_LinearLayout.setLayoutParams(paramsWrapContent);
		
		this.addView(_LinearLayout);
		
		paramsWrapContent.leftMargin = 5;
		paramsWrapContent.rightMargin = 5;
		
		// TODO:
		_UserID = new TextView(_Context);
		_UserID.setText(userID);
		_UserID.setLayoutParams(paramsWrapContent);
		
		_Message = new TextView(_Context);
		_Message.setText(text);
		_Message.setBackgroundResource(image);
		_Message.setLayoutParams(paramsWrapContent);

		if (LEFT == direction) {
			_LinearLayout.addView(_UserID);
			_LinearLayout.addView(_Message);
		} else {
			_LinearLayout.addView(_Message);
			_LinearLayout.addView(_UserID);
		}
	}
	
	public String getText() {
		if (null != _Message) return _Message.getText().toString();
		else return "";
	}

}
